/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package core;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import javax.swing.JTextArea;

/**
 *
 * @author pchr
 */
public class parser {
    private Domain domain;
    
    public parser(){}
    
    public Domain parse(File theFile, JTextArea ParselArea){
        domain = new Domain();
        ParselArea.setText("");
        try {
            BufferedReader in = new BufferedReader(new FileReader(theFile.getPath()));
            String dataLine;
            //StringTokenizer 
            String st[];
            int n=0;
            while ((dataLine = in.readLine()) != null) {
                ++n;
            }
            in.close();
            in = new BufferedReader(new FileReader(theFile.getPath()));
            
            n=0;
            int switchString=0;
            ParselArea.append(theFile.getCanonicalPath()+'\n');
            ParselArea.append("==================================="+'\n');
            while ((dataLine = in.readLine()) != null) {
                st = dataLine.split(" ");
                switchString=0;
                for(int i=0;i<st.length;i++){
                    ParselArea.append(st[i]+" ");
                }
                ParselArea.append(" "+'\n');
                if(st[0].equalsIgnoreCase("κόμβος")||st[0].equalsIgnoreCase("κομβος")){switchString=1;}
                if(st[0].equalsIgnoreCase("υλικό")||st[0].equalsIgnoreCase("υλικο")){switchString=2;}
                if(st[0].equalsIgnoreCase("διατομή")||st[0].equalsIgnoreCase("διατομη")){switchString=3;}
                if(st[0].equalsIgnoreCase("στοιχείο")||st[0].equalsIgnoreCase("στοιχειο")){switchString=4;}
                if(st[0].equalsIgnoreCase("δύναμη")||st[0].equalsIgnoreCase("δυναμη")){switchString=5;}
                if(st[0].equalsIgnoreCase("μετατόπιση")||st[0].equalsIgnoreCase("μετατοπιση")){switchString=6;}
                
                switch(switchString){
                    case 1: this.parseNode(st); break;
                    case 2: this.parseMaterial(st); break;
                    case 3: this.parseSection(st); break;
                    case 4: this.parseElement(st); break;
                    case 5: this.parseLoad(st); break;
                    case 6: this.parseConstraint(st); break;
                }

                
                ++n;
            }
            in.close();
 
        } catch (IOException e) {
        }
        
        
        
        return domain;
    }
    
    private void parseNode(String[] st){
        Node aNode = new Node(Integer.parseInt(st[1]),Double.parseDouble(st[2]));
        domain.putNode(aNode);
    }
    
    private void parseMaterial(String[] st){
        Material aMaterial = new Material(Integer.parseInt(st[1]),Double.parseDouble(st[2]));
        domain.putMaterial(aMaterial);
    }
    
    private void parseSection(String[] st){
        int wmat=Integer.parseInt(st[3]);
        Section aSection = new Section(Integer.parseInt(st[1]),Double.parseDouble(st[2]),domain.getMaterial(wmat));
        domain.putSection(aSection);
    }
    
    private void parseElement(String[] st){
        int wsec=Integer.parseInt(st[4]);
        int wn1=Integer.parseInt(st[2]);
        int wn2=Integer.parseInt(st[3]);
        Element aElement = new Element(Integer.parseInt(st[1]),domain.getNode(wn1),domain.getNode(wn2),domain.getSection(wsec));
        domain.putElement(aElement);
    }
    
    private void parseLoad(String[] st){
        int wn=Integer.parseInt(st[1]);
        Load aLoad = new Load(domain.getNode(wn),Double.parseDouble(st[2]));
        domain.putLoad(aLoad);
    }
    
    private void parseConstraint(String[] st){
        int wn=Integer.parseInt(st[1]);
        Constraint aConstraint = new Constraint(domain.getNode(wn),Double.parseDouble(st[2]));
        domain.putConstraint(aConstraint);
    }

}
