/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gui;

import core.*;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.util.Iterator;
import java.util.Map;

/**
 *
 * @author fotis
 */
public class DrawPanelInput extends DrawPanel{

    public DrawPanelInput() {
        super();
    }


    @Override
    public void paintComponent(Graphics g) {
        //System.out.println("paintComponent");
	// Define graphics
        Graphics2D g2 = (Graphics2D) g;
        // Get dimensions
	int width  = this.getWidth();
	int height = this.getHeight();
	// Clear window
	g2.setBackground(Color.BLACK);
	g2.clearRect(0, 0, width, height);
        
        g2.setColor(Color.GRAY);
        
        xs=width/20;
        xe=width-width/20;
        ys=height/2;
        
        g2.setStroke(new BasicStroke(1));
        g2.drawLine(xs, ys, xe/2, ys);
        g2.drawLine(xe/2, ys, xe, ys);
        
        if(domain!=null){
        
        g2.setColor(Color.BLUE);
        g2.drawString("κόμβοι   : "+domain.getNodes().size(), 10, 20);
        g2.setColor(Color.GREEN);
        g2.drawString("στοιχεία : "+domain.getElements().size(), 10, 40);
        g2.setColor(Color.RED);
        g2.drawString("φορέας", (xs+xe)/2, 20);
        
        g2.setColor(Color.LIGHT_GRAY);
        g2.drawString("επιβαλλόμενη μετατόπιση:", 10, height-20);
        int x1=130; int y1=height-25;
        g2.drawLine(x1+10, y1, x1+24, y1);
        g2.drawLine(x1+24, y1, x1+22, y1+2);
        g2.drawLine(x1+24, y1, x1+22, y1-2);
        //g2.drawLine(x1+4, y1, x1+2, y1+2);
        //g2.drawLine(x1+4, y1, x1+2, y1-2);
        g2.setColor(Color.YELLOW);
        g2.drawString("επιβαλλόμενη δύναμη    :", 10, height-40);
        x1=130; y1=height-45;
        g2.drawLine(x1+10, y1, x1+24, y1);
        g2.drawLine(x1+24, y1, x1+22, y1+2);
        g2.drawLine(x1+24, y1, x1+22, y1-2);
        //g2.drawLine(x1+4, y1, x1+2, y1+2);
        //g2.drawLine(x1+4, y1, x1+2, y1-2);
        
        this.drawElements(g2);
        this.drawNodes(g2);
        this.drawConstraints(g2);
        this.drawLoads(g2);
        }
        
    }
    
    public void drawElements(Graphics2D g2){
        int x1,x2;
        Map<Integer,Element> theElements=domain.getElements();
        for(Iterator<Element> it=theElements.values().iterator(); it.hasNext();){
            Element theElement = it.next();
            x1=this.xTransformation(theElement.getN1().getX());
            x2=this.xTransformation(theElement.getN2().getX());

            g2.setColor(Color.GREEN);
            g2.setStroke(new BasicStroke(1));
            g2.drawLine(x1, ys, x2, ys);
            g2.setStroke(new BasicStroke(1));
            g2.drawString(Integer.toString(theElement.getId()), (x1+x2)/2, ys-10);
        }
    }
    
    public void drawNodes(Graphics2D g2){
        int x1;
        Map<Integer,Node> theNodes=domain.getNodes();
        for(Iterator<Node> it=theNodes.values().iterator(); it.hasNext();){
            Node theNode = it.next();
            x1=this.xTransformation(theNode.getX());

            g2.setColor(Color.BLUE);
            g2.setStroke(new BasicStroke(1));
            g2.drawLine(x1, ys-5, x1, ys);
            g2.drawLine(x1, ys+5, x1, ys);
            g2.setStroke(new BasicStroke(1));
            g2.drawString(Integer.toString(theNode.getId()), x1, ys+20);
        }
    }
    
    public void drawConstraints(Graphics2D g2){
        int x1;
        Map<Integer,Constraint> theConstraints=domain.getConstraints();
        for(Iterator<Constraint> it=theConstraints.values().iterator(); it.hasNext();){
            Constraint theConstraint = it.next();
            x1=this.xTransformation(theConstraint.getNode().getX());

            g2.setColor(Color.LIGHT_GRAY);
            g2.setStroke(new BasicStroke(1));
            g2.drawLine(x1-7, ys-25, x1+7, ys-25);
            
            g2.drawLine(x1+7, ys-25, x1+5, ys-27);
            g2.drawLine(x1+7, ys-25, x1+5, ys-23);
            
            //g2.drawLine(x1+4, ys-25, x1+2, ys-27);
            //g2.drawLine(x1+4, ys-25, x1+2, ys-23);
        }
    }
    
    public void drawLoads(Graphics2D g2){
        int x1;
        Map<Integer,Load> theLoads=domain.getLoads();
        for(Iterator<Load> it=theLoads.values().iterator(); it.hasNext();){
            Load theLoad = it.next();
            x1=this.xTransformation(theLoad.getNode().getX());

            g2.setColor(Color.YELLOW);
            g2.setStroke(new BasicStroke(1));
            g2.drawLine(x1-7, ys-25, x1+7, ys-25);
            
            g2.drawLine(x1+7, ys-25, x1+5, ys-27);
            g2.drawLine(x1+7, ys-25, x1+5, ys-23);
            
            //g2.drawLine(x1+4, ys-25, x1+2, ys-27);
            //g2.drawLine(x1+4, ys-25, x1+2, ys-23);
        }
    }
}
