/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gui;

import core.*;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.Iterator;
import java.util.Map;

/**
 *
 * @author pchr
 */
public class DrawPanelOutput extends DrawPanel {
    int flag_res=0;
    boolean flag_yaxis=false;
    boolean falg_values=false;

    public DrawPanelOutput(){
        super();
    }
    
    public void setRes(int inres){
        flag_res=inres;
    }
    
    public void setYaxis(boolean inres){
        flag_yaxis=inres;
    }
    
    public void setValues(boolean inres){
        falg_values=inres;
    }


    @Override
    public void paintComponent(Graphics g) {
        //System.out.println("paintComponent");
	// Define graphics
        Graphics2D g2 = (Graphics2D) g;
        // Get dimensions
	int width  = this.getWidth();
	int height = this.getHeight();
	// Clear window
	g2.setBackground(Color.BLACK);
	g2.clearRect(0, 0, width, height);
        
        g2.setColor(Color.GRAY);
        
        xs=width/20;
        xe=width-width/20;
        ys=height/2;
        
        yupp=height - height/20;
        ylow=height/20;
        
        g2.setStroke(new BasicStroke(1));

        g2.drawLine(xs, ys, xe, ys);
        g2.drawLine(xs, ys, xs, ylow);
        g2.drawLine(xs, ys, xs, yupp);
        
        switch(flag_res){
            case 1: this.drawU(g2); break;
            case 2: this.drawF(g2); break;
            case 3: this.drawS(g2); break;
            case 4: this.drawUi(g2); break;
            default: break;
        }
        
    }
    
    private void drawU(Graphics2D g2){
        int x1,x2;
        int y1,y2;
        double ymin,ymax;
        
        ymin = domain.getMinU();
        ymax = domain.getMaxU();
        
        //String sd;
        //DecimalFormat Places = new DecimalFormat("0.0000");
        
        DecimalFormatSymbols comma =new DecimalFormatSymbols();
        comma.setDecimalSeparator('.');
        DecimalFormat Places = new DecimalFormat("0.00E0",comma);
        String sd;
        
        if(this.flag_yaxis){
            g2.setColor(Color.GREEN);
            for(int i=0; i<=12; i++){
                //sd = Places.format( (ymin+ymax)/2. );
                //g2.drawString(sd, xs-30, ys);
                sd = Places.format( ymax+i*(ymin-ymax)/12. );
                g2.drawString(sd, xs-40, this.yTransformation(ymax+i*(ymin-ymax)/12., ymax, ymin));
            }
        }
        
        Map<Integer,Element> theElements=domain.getElements();
        for(Iterator<Element> it=theElements.values().iterator(); it.hasNext();){
            Element theElement = it.next();
            x1=this.xTransformation(theElement.getN1().getX());
            x2=this.xTransformation(theElement.getN2().getX());
            
            y1=this.yTransformation(theElement.getU()[0],ymax,ymin);
            y2=this.yTransformation(theElement.getU()[1],ymax,ymin);

            g2.setColor(Color.WHITE);
            g2.setStroke(new BasicStroke(1));
            g2.drawLine(x1, y1, x2, y2);
            
            g2.setColor(Color.LIGHT_GRAY);
            g2.setStroke(new BasicStroke(1));
            g2.drawLine(x1, ys, x1, y1);
            g2.drawLine(x2, ys, x2, y2);
            
            //DecimalFormat Places = new DecimalFormat("0.0000");
            if(this.falg_values){
                String sd1 = Places.format(theElement.getU()[0]);
                String sd2 = Places.format(theElement.getU()[1]);
                g2.setColor(Color.RED);
                g2.drawString(sd1, x1, y1);
                g2.drawString(sd2, x2, y2);
            }
            
        }
    }
    
    private void drawF(Graphics2D g2){
        int x1,x2;
        int y1,y2;
        double ymin,ymax;
        
        ymin = domain.getMinF();
        ymax = domain.getMaxF();
        
        DecimalFormatSymbols comma =new DecimalFormatSymbols();
        comma.setDecimalSeparator('.');
        DecimalFormat Places = new DecimalFormat("0.00E0",comma);
        String sd;
        if(this.flag_yaxis){
            g2.setColor(Color.GREEN);
            for(int i=0; i<=12; i++){
                //sd = Places.format( (ymin+ymax)/2. );
                //g2.drawString(sd, xs-30, ys);
                sd = Places.format( ymax+i*(ymin-ymax)/12. );
                g2.drawString(sd, xs-40, this.yTransformation(ymax+i*(ymin-ymax)/12., ymax, ymin));
            }
        }
        
        Map<Integer,Element> theElements=domain.getElements();
        for(Iterator<Element> it=theElements.values().iterator(); it.hasNext();){
            Element theElement = it.next();
            x1=this.xTransformation(theElement.getN1().getX());
            x2=this.xTransformation(theElement.getN2().getX());
            
            y1=this.yTransformation(theElement.getF()[0],ymax,ymin);
            y2=this.yTransformation(theElement.getF()[1],ymax,ymin);

            g2.setColor(Color.WHITE);
            g2.setStroke(new BasicStroke(1));
            g2.drawLine(x1, y1, x2, y2);
            
            g2.setColor(Color.LIGHT_GRAY);
            g2.setStroke(new BasicStroke(1));
            g2.drawLine(x1, ys, x1, y1);
            g2.drawLine(x2, ys, x2, y2);
            
            //DecimalFormat Places = new DecimalFormat("0.0000");
            if(this.falg_values){
                String sd1 = Places.format(theElement.getF()[0]);
                String sd2 = Places.format(theElement.getF()[1]);
                g2.setColor(Color.RED);
                g2.drawString(sd1, (x1+x2)/2, (y1+y2)/2-10);
                //g2.drawString(sd2, x2, y2);
            }
            
        }
    }
    
        private void drawS(Graphics2D g2){
        int x1,x2;
        int y1,y2;
        double ymin,ymax;
        
        ymin = domain.getMinS();
        ymax = domain.getMaxS();
        
        DecimalFormatSymbols comma =new DecimalFormatSymbols();
        comma.setDecimalSeparator('.');
        DecimalFormat Places = new DecimalFormat("0.00E0",comma);
        String sd;
        if(this.flag_yaxis){
            g2.setColor(Color.GREEN);
            for(int i=0; i<=12; i++){
                //sd = Places.format( (ymin+ymax)/2. );
                //g2.drawString(sd, xs-30, ys);
                sd = Places.format( ymax+i*(ymin-ymax)/12. );
                g2.drawString(sd, xs-40, this.yTransformation(ymax+i*(ymin-ymax)/12., ymax, ymin));
            }
        }
        
        Map<Integer,Element> theElements=domain.getElements();
        for(Iterator<Element> it=theElements.values().iterator(); it.hasNext();){
            Element theElement = it.next();
            x1=this.xTransformation(theElement.getN1().getX());
            x2=this.xTransformation(theElement.getN2().getX());
            
            y1=this.yTransformation(theElement.getS()[0],ymax,ymin);
            y2=this.yTransformation(theElement.getS()[1],ymax,ymin);

            g2.setColor(Color.WHITE);
            g2.setStroke(new BasicStroke(1));
            g2.drawLine(x1, y1, x2, y2);
            
            g2.setColor(Color.LIGHT_GRAY);
            g2.setStroke(new BasicStroke(1));
            g2.drawLine(x1, ys, x1, y1);
            g2.drawLine(x2, ys, x2, y2);
            
            //DecimalFormat Places = new DecimalFormat("0.0000");
            if(this.falg_values){
                String sd1 = Places.format(theElement.getS()[0]);
                String sd2 = Places.format(theElement.getS()[1]);
                g2.setColor(Color.RED);
                g2.drawString(sd1, (x1+x2)/2, (y1+y2)/2-10);
                //g2.drawString(sd2, x2, y2);
            }
            
        }
    }
    
    private void drawUi(Graphics2D g2){
        int x1,x2;
        int y1,y2;
        double ymin,ymax;
        
        ymin = domain.getMinUi();
        ymax = domain.getMaxUi();
        
        DecimalFormatSymbols comma =new DecimalFormatSymbols();
        comma.setDecimalSeparator('.');
        DecimalFormat Places = new DecimalFormat("0.00E0",comma);
        String sd;
        if(this.flag_yaxis){
            g2.setColor(Color.GREEN);
            for(int i=0; i<=12; i++){
                //sd = Places.format( (ymin+ymax)/2. );
                //g2.drawString(sd, xs-30, ys);
                sd = Places.format( ymax+i*(ymin-ymax)/12. );
                g2.drawString(sd, xs-40, this.yTransformation(ymax+i*(ymin-ymax)/12., ymax, ymin));
            }
        }
        
        Map<Integer,Element> theElements=domain.getElements();
        for(Iterator<Element> it=theElements.values().iterator(); it.hasNext();){
            Element theElement = it.next();
            x1=this.xTransformation(theElement.getN1().getX());
            x2=this.xTransformation(theElement.getN2().getX());
            
            y1=this.yTransformation(theElement.getUi()[0],ymax,ymin);
            y2=this.yTransformation(theElement.getUi()[0],ymax,ymin);

            g2.setColor(Color.WHITE);
            g2.setStroke(new BasicStroke(1));
            g2.drawLine(x1, y1, x2, y2);
            
            g2.setColor(Color.LIGHT_GRAY);
            g2.setStroke(new BasicStroke(1));
            g2.drawLine(x1, ys, x1, y1);
            g2.drawLine(x2, ys, x2, y2);
            
            //DecimalFormat Places = new DecimalFormat("0.0000");
            if(this.falg_values){
                String sd1 = Places.format(theElement.getUi()[0]);
                g2.setColor(Color.RED);
                g2.drawString(sd1, (x1+x2)/2, (y1+y2)/2-10);
            }
        }
    }


}
